SystemOrganization addCategory: #OrionBrowser!

Object subclass: #ASBrowser
	instanceVariableNames: 'selectedVersion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrionBrowser'!

!ASBrowser class methodsFor: 'as yet unclassified' stamp: 'janniklaval 12/24/2012 18:36'!
open 

	self new browser openOn: ASSystem root first! !

!ASBrowser methodsFor: 'as yet unclassified' stamp: 'janniklaval 12/24/2012 18:08'!
actionsFor: each
	|posAction elements listOfAct |

	elements :=  each selection mooseInterestingEntity.
	posAction := (((ASAction withAllSubclasses flatCollect: [:act | Pragma allNamed: #AntaresActionFor: in: act class])
					select:[:e | e arguments includes: elements class asString asSymbol]) collect:[:e | e methodClass soleInstance]) asOrderedCollection.
	listOfAct := OrderedCollection new.
	posAction do:[:ie | 
						|depend|
						depend := ie needs: elements.
						depend isNil 
							ifTrue:[
								listOfAct add:(
								(GLMAction new)
									action:[:anAct | 
										elements currentContext isModifiable ifTrue:[
											ie new entity: elements; antaresModel: elements currentContext; manualRun.
											elements currentContext system announcer announce: ASModelChanged]
										ifFalse:[
											ie new entity:elements; runOnNewVersionFrom: elements currentContext.
											elements currentContext system announcer announce: ASModelAdded
										]
									];
									title:ie description;
									yourself).]
							ifFalse:[
								depend do:[:anEl |
									listOfAct add:(
									(GLMAction new)
										action:[:anAct | 
											elements currentContext isModifiable ifTrue:[
												ie new entity:elements; to:anEl; antaresModel: elements currentContext; manualRun.
												elements currentContext system announcer announce: ASModelChanged]
											ifFalse:[
												ie new entity:elements; to:anEl; runOnNewVersionFrom: elements currentContext.
												elements currentContext system announcer announce: ASModelAdded]
										];
										title:anEl mooseName;
										category:ie description;
										yourself).]].				
				].
	^listOfAct.! !

!ASBrowser methodsFor: 'as yet unclassified' stamp: 'janniklaval 12/24/2012 18:08'!
browser
	"
		self new browser openOn: ASSystem root
	"
	| browser  |
	
	browser := GLMTabulator new.
	
	browser column: #models span: 1; column: [:c | c row:#versions; row: #changes] span: 1; column: #categories span: 4.
	(browser transmit) to: #models; andShow: [:b |
		b list
			format:[:system | system name];
			display: [:each | each ].
	].
	
	(browser transmit) from: #models; to: #versions; andShow: [:b | 
		b tree
			allExpanded;
			format:[:system | system name];
			display: [:each | each antaresModels select:[:om | om parentModel = nil]];
			children: [:each | each childrenModel];
			act: [:each | each selection inspect] entitled: 'inspect';
			act: [:each | |new|
				new := each selection createNewChildVersion. ASSystem announcer announce: ASModelAdded. browser announce: ASAnnouncement] entitled: 'create a child version';
			act: [:each | each selection delete. ASSystem announcer announce: ASModelRemoved. browser announce: ASAnnouncement] entitled: 'delete'.
	].
	(browser transmit) to: #changes; from: #versions; andShow: [:b |
		b list
			display: [:each | each changes];
			title: [ :each | each changes size asString, ' changes'].
	].
	(browser transmit) to: #categories; from: #versions; andShow: [:b |
		b finder
			show: [:a |
				a custom: (self groupList).
				a custom: self entityNavigation.
			].
	 ].
	browser subscribe: ASAnnouncement do: [browser update].
	^ browser! !

!ASBrowser methodsFor: 'as yet unclassified' stamp: 'janniklaval 1/16/2013 10:13'!
displayFor: anObject
	| entity pragmaValueAssociations |
	entity := anObject mooseInterestingEntity.
	pragmaValueAssociations := entity complexPropertyPragmas collect: [ :pragma | 
		pragma -> (anObject mooseInterestingEntity perform: pragma selector) mooseInterestingEntity ].
	^ (pragmaValueAssociations
		reject: [ :association | 
			association value isNil or: [ 
				association value isCollection and: [ 
					association value isEmpty ] ] ])
		sorted: [:a :b | 
			(a key argumentAt: 1) asLowercase asString < (b key argumentAt: 1) asLowercase asString ]! !

!ASBrowser methodsFor: 'as yet unclassified' stamp: 'janniklaval 1/16/2013 10:26'!
entityNavigation
	^ GLMListPresentation new
			title: 'Navigation';
			display: [ :anObject | |entity |
				entity := anObject mooseInterestingEntity.
				(entity mooseInterestingEntity isKindOf: FAMIXEntity) ifFalse:[self selectedVersion: entity] ifTrue:[entity currentContext: self selectedVersion.].
				self displayFor: entity value.
			];
			when: [:input | input mooseInterestingEntity isCollection not or: [input mooseInterestingEntity isKindOf: MooseModel] ];
			dynamicActionsOnSelection: [ :list | list selection mooseInterestingEntity mooseFinderActions ].! !

!ASBrowser methodsFor: 'as yet unclassified' stamp: 'janniklaval 12/24/2012 18:08'!
groupList
	^ GLMListPresentation new
			beMultiple;
			showOnly: 50;
			display: [:e | e mooseInterestingEntity];
			send: [:each | each isNil ifTrue: [nil] ifFalse: [each asMooseGroup]];
			format: #mooseName;
			title: [ :each | each mooseInterestingEntity size asString, ' items'];
			when: [:input | (input mooseInterestingEntity isKindOf: MooseGroup) or:[
					(input mooseInterestingEntity isKindOf: Collection) and:[(input mooseInterestingEntity isKindOf: ByteSymbol)not]]];
			dynamicActionsOnSelection: [ :list | OrderedCollection new 
					addAll: list selection mooseInterestingEntity mooseFinderActions;
					addAll: (self actionsFor: list);
					yourself].
				
	! !

!ASBrowser methodsFor: 'accessing' stamp: 'janniklaval 12/23/2012 08:25'!
selectedVersion
	^ selectedVersion! !

!ASBrowser methodsFor: 'accessing' stamp: 'janniklaval 12/23/2012 08:25'!
selectedVersion: anObject
	selectedVersion := anObject! !

Object subclass: #OrionBrowser
	instanceVariableNames: 'selectedVersion browser actionDict selectedPackageTop selectedPackageBottom selectedClassTop selectedClassBottom'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrionBrowser'!

!OrionBrowser class methodsFor: 'as yet unclassified' stamp: 'na 1/19/2013 12:46'!
open 

	self new browser openOn: ASSystem root! !

!OrionBrowser methodsFor: 'gui' stamp: 'na 1/19/2013 12:47'!
browser

	browser := GLMTabulator new.
	
	browser
		column: #models span: 1;
		column: [:c | c
			row: [:r | r column: #packagesTop; column: #classesTop; column: #methodsTop ] ;
			row: [:r | r column: #packagesBottom; column: #classesBottom; column: #methodsBottom ]]
		span: 3 ;
		column: #summary span: 1.

	self
		browserModels ;
		browserRow: #top ;
		browserRow: #bottom ;
		browserSummary.
	
	browser subscribe: ASAnnouncement do: [ browser update].
	^ browser! !

!OrionBrowser methodsFor: 'gui' stamp: 'na 1/17/2013 17:49'!
browserClasses: myRow

	| myPane fromPane mySelected oppositeSelected |
	
	(myRow == #top)
		ifTrue: [myPane := #classesTop.        fromPane := #packagesTop.       mySelected := #selectedPackageTop:. oppositeSelected := #selectedPackageBottom.]
		ifFalse: [ myPane := #classesBottom. fromPane := #packagesBottom. mySelected := #selectedPackageBottom:. oppositeSelected := #selectedPackageTop.].

	(browser transmit) to: myPane; from: fromPane; andShow: [:b | | gmlList |
		gmlList := b list.
		gmlList
			display: [:anEntity | self perform: mySelected with: anEntity. anEntity classes ];
			title: [ :each | ' Classes'] ;
			selectionAct: [:list | list selection inspect] entitled:  'Inspect'.
		
		self contextMenuOn: gmlList action: #removeClass entitled: 'Remove'.			
		self contextMenuOn: gmlList moveAction: #moveClass entitled: 'Move to other package' withContainer: oppositeSelected.
	].
! !

!OrionBrowser methodsFor: 'gui' stamp: 'na 1/16/2013 22:27'!
browserMethods: myRow

	| myPane fromPane mySelected oppositeSelected |
	
	(myRow == #top)
		ifTrue: [myPane := #methodsTop.         fromPane := #classesTop.      mySelected := #selectedClassTop:. oppositeSelected := #selectedClassBottom.]
		ifFalse: [ myPane := #methodsBottom. fromPane :=#classesBottom. mySelected := #selectedClassBottom:. oppositeSelected := #selectedClassTop.].

	(browser transmit) to: myPane; from: fromPane; andShow: [:b | | gmlList |
		gmlList := b list.
		gmlList
			display: [:anEntity | self perform: mySelected with: anEntity. anEntity methods ];
			title: [ :each | ' Methods'].
		
		self contextMenuOn: gmlList action: #removeMethod entitled: 'Remove'.			
		self contextMenuOn: gmlList moveAction: #moveMethod entitled: 'Move to other class' withContainer: oppositeSelected.
	].
! !

!OrionBrowser methodsFor: 'gui' stamp: 'na 1/19/2013 12:52'!
browserModels

	(browser transmit) to: #models; andShow: [:b | | gmlTree |
		gmlTree := b tree.
		gmlTree
			allExpanded;
			display: [:systems | systems flatCollect: [:aSystem | aSystem antaresModels select:[:versions | versions parentModel isNil]]];
			format:[:aVersion | aVersion name];
			children: [:aVersion | aVersion childrenModel];

			selectionSpawn: [:theList |
				|tmpBrowser|
				tmpBrowser := GLMTabulator new row: #one; "initialExtent: 100@100 ;" yourself.
				tmpBrowser
					transmit to: #one ; andShow: [:t |
						t list
							display: [:listItem | listItem changes] ;
							format:[:aChange | aChange printWorkspace];
							title: [ :each | ' Changes in ' , (each name)] ].
				tmpBrowser startOn: theList selection
				] entitled: 'List changes' ;

			selectionAct: [:theList | 
						theList selection createNewChildVersion.
						browser announce: ASAnnouncement]
				entitled: 'Create a child version' ;

			selectionAct: [:theList | 
						theList selection delete.
						browser announce: ASAnnouncement]
				entitled: 'Delete version' .

		self contextMenuOn: gmlTree action: #addPackage entitled: 'Add a package'.	
	].
! !

!OrionBrowser methodsFor: 'gui' stamp: 'na 1/17/2013 17:50'!
browserPackages: myRow

	| myPane guardCondition |
	
	(myRow == #top)
		ifTrue: [myPane := #packagesTop] ifFalse: [ myPane := #packagesBottom].
	
	(browser transmit) to: myPane ; from:#models; andShow: [:b | | gmlList |
		gmlList := b list.
		gmlList
			display: [:model |
				self selectedVersion: model.
				(model allWithType: ASPackage) sorted: [:c1 :c2 | c1 name < c2 name] ] ;
			title: [ :each | ' Packages'];
			selectionAct: [:list | list selection inspect] entitled:  'Inspect'.

		self contextMenuOn: gmlList action: #addClass entitled: 'Add class'.			
		self contextMenuOn: gmlList action: #removePackage entitled: 'Remove'.			
	].
! !

!OrionBrowser methodsFor: 'gui' stamp: 'na 1/16/2013 18:01'!
browserRow: myRow

	self 
		browserPackages: myRow ;
		browserClasses: myRow ;
		browserMethods: myRow.
	! !

!OrionBrowser methodsFor: 'gui' stamp: 'na 1/16/2013 18:04'!
browserSummary

	(browser transmit) to: #summary; from:#models; andShow: [:b |
		b list
			display: [:aModel | {  'nb package=' , ((aModel allWithType: ASPackage) size asString) .  'nb class=' , ((aModel allWithType: ASClass) size asString) .  'nb meth=' , ((aModel allWithType: ASMethod) size asString)}  ];
			format: [:aString | aString];
			title: [ :each | ' Metrics'].
	].

	(browser transmit) to: #summary ; from:#packagesTop; andShow: [:b |
		b list
			display: [:anEntity | {   'nb package=1'  .  'nb class=' , ((anEntity classes) size asString) }];
			title: [ :each | ' Metrics'].
	].

	(browser transmit) to: #summary ; from:#packagesBottom; andShow: [:b |
		b list
			display: [:anEntity | {   'nb package=1'  .  'nb class=' , ((anEntity classes) size asString) }];
			title: [ :each | ' Metrics'].
	].

	(browser transmit) to: #summary; from:#classesTop; andShow: [:b |
		b list
			display: [:anEntity | {   'nb package=1'  . 'nb class= 1' .   'nb meth=' , ((anEntity methods) size asString)}];
			title: [ :each | ' Metrics'].
	].

	(browser transmit) to: #summary; from:#classesBottom; andShow: [:b |
		b list
			display: [:anEntity | {   'nb package=1'  . 'nb class= 1' .   'nb meth=' , ((anEntity methods) size asString)}];
			title: [ :each | ' Metrics'].
	].

	(browser transmit) to: #summary; from:#methodsTop; andShow: [:b |
		b list
			display: [:anEntity | {   'nb package=1'  . 'nb class= 1' .   'nb meth=1' }];
			title: [ :each | ' Metrics'].
	].

	(browser transmit) to: #summary; from:#methodsBottom; andShow: [:b |
		b list
			display: [:anEntity | {   'nb package=1'  . 'nb class= 1' .   'nb meth=1' }];
			title: [ :each | ' Metrics'].
	].
! !

!OrionBrowser methodsFor: 'gui' stamp: 'na 1/17/2013 17:54'!
contextMenuOn: gmlPresentation action: aToken entitled: aString

	gmlPresentation selectionAct: [:list | self doAction: aToken onEntity: (list selection)] entitled: aString.
! !

!OrionBrowser methodsFor: 'gui' stamp: 'na 1/16/2013 22:29'!
contextMenuOn: gmlList moveAction: aToken entitled: aString withContainer: oppositeEntity

	gmlList selectionAct: [:list | self doMoveAction: aToken onEntity: (list selection) withContainerFrom: (self perform: oppositeEntity)] entitled: aString.
! !

!OrionBrowser methodsFor: 'actions' stamp: 'na 1/19/2013 10:58'!
doAction: anAction onEntity: anEntity

	self perform: (actionDict at: anAction) with: anEntity .

	browser announce: ASAnnouncement.! !

!OrionBrowser methodsFor: 'actions' stamp: 'na 1/19/2013 10:58'!
doMoveAction: anAction onEntity: anEntity withContainerFrom: anotherEntity

	self perform: (actionDict at: anAction) with: anEntity with: anotherEntity.

	browser announce: ASAnnouncement.! !

!OrionBrowser methodsFor: 'gui' stamp: 'na 1/19/2013 13:43'!
getNameDialogue: aString
	
	| wizardControl  wizardPane textFieldPart defaultText |

	defaultText :=  '--Enter name--'.
	
	wizardControl := WizardControl new.
	wizardControl renderer: MerlinMorphicWizardRenderer new.
	
	wizardPane := WizardSinglePane new.
	
	textFieldPart := TextFieldPart  new
									inGroupboxNamed: aString;
									defaultValue: defaultText ;
									yourself.
	
	wizardPane row: textFieldPart associatedTo: #textFieldValue.
		
	wizardControl 
		addPane: wizardPane.
		
	wizardControl open. 
	((wizardControl wizardInformations at: #textFieldValue) = defaultText)
		ifTrue: [^ nil]
		ifFalse: [^ wizardControl wizardInformations at: #textFieldValue]! !

!OrionBrowser methodsFor: 'initialize-release' stamp: 'na 1/19/2013 11:00'!
initialize 

	actionDict := SmallDictionary new.
	actionDict
		at: #addPackage put: #myAddPackage: ;
		at: #removePackage put: #myRemovePackage: ;
		at: #addClass put: #myAddClass: ;
		at: #removeClass put: #myRemoveClass: ;
		at: #moveClass put: #myMoveClass:to:;
		at: #removeMethod put: #myRemoveMethod: ;
		at: #moveMethod put: #myMoveMethod:to:.
! !

!OrionBrowser methodsFor: 'actions' stamp: 'na 1/19/2013 13:45'!
myAddClass: anEntity
	| newName |
	
	newName := self getNameDialogue:  'New class name'.

	newName notNil ifTrue: [ 
		(ASActionAddClass new
			isManual: true ;
			antaresModel: self selectedVersion;
			entity: anEntity ;
			stringName: newName )
		run ]
! !

!OrionBrowser methodsFor: 'actions' stamp: 'na 1/19/2013 13:44'!
myAddPackage: anEntity
	| newName |
	newName := self getNameDialogue:  'New package name'.

	newName notNil ifTrue: [ 
		(ASActionAddPackage new
			isManual: true ;
			antaresModel: self selectedVersion;
			entity: anEntity ;
			stringName: newName )
		run ]
! !

!OrionBrowser methodsFor: 'actions' stamp: 'na 1/19/2013 11:00'!
myMoveClass: anEntity to: newPackage

	
	(ASActionMoveClass new
		isManual: true ;
		antaresModel: self selectedVersion;
		entity: anEntity ;
		newContainer: newPackage )
	run. 
! !

!OrionBrowser methodsFor: 'actions' stamp: 'na 1/19/2013 11:01'!
myMoveMethod: anEntity to: newClass

	(ASActionMoveMethod new
		isManual: true ;
		antaresModel: self selectedVersion;
		entity: anEntity ;
		newContainer: newClass )
	run. 
! !

!OrionBrowser methodsFor: 'actions' stamp: 'na 1/19/2013 11:01'!
myRemoveClass: anEntity

	(ASActionRemoveClass new
		isManual: true ;
		antaresModel: self selectedVersion;
		entity: anEntity )
	run. 
! !

!OrionBrowser methodsFor: 'actions' stamp: 'na 1/19/2013 11:01'!
myRemoveMethod: anEntity

	(ASActionRemoveMethod new
		isManual: true ;
		antaresModel: self selectedVersion;
		entity: anEntity )
	run. 
! !

!OrionBrowser methodsFor: 'actions' stamp: 'na 1/19/2013 11:01'!
myRemovePackage: anEntity

	(ASActionRemovePackage new
		isManual: true ;
		antaresModel: self selectedVersion;
		entity: anEntity )
	run. 
! !

!OrionBrowser methodsFor: 'accessing' stamp: 'na 1/16/2013 22:20'!
selectedClassBottom
	^ selectedClassBottom! !

!OrionBrowser methodsFor: 'accessing' stamp: 'na 1/16/2013 22:20'!
selectedClassBottom: anObject
	selectedClassBottom := anObject! !

!OrionBrowser methodsFor: 'accessing' stamp: 'na 1/16/2013 22:19'!
selectedClassTop
	^ selectedClassTop! !

!OrionBrowser methodsFor: 'accessing' stamp: 'na 1/16/2013 22:19'!
selectedClassTop: anObject
	selectedClassTop := anObject! !

!OrionBrowser methodsFor: 'accessing' stamp: 'na 1/16/2013 22:19'!
selectedPackageBottom
	^ selectedPackageBottom! !

!OrionBrowser methodsFor: 'accessing' stamp: 'na 1/16/2013 22:19'!
selectedPackageBottom: anObject
	selectedPackageBottom := anObject! !

!OrionBrowser methodsFor: 'accessing' stamp: 'na 1/16/2013 22:19'!
selectedPackageTop
	^ selectedPackageTop! !

!OrionBrowser methodsFor: 'accessing' stamp: 'na 1/16/2013 22:19'!
selectedPackageTop: anObject
	selectedPackageTop := anObject! !

!OrionBrowser methodsFor: 'accessing' stamp: 'na 1/15/2013 15:31'!
selectedVersion
	^ selectedVersion! !

!OrionBrowser methodsFor: 'accessing' stamp: 'na 1/15/2013 15:31'!
selectedVersion: anObject
	selectedVersion := anObject! !
